=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class AddressValidationResultsMessage
    attr_accessor :code

    attr_accessor :source

    attr_accessor :text

    attr_accessor :type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'code' => :'code',
        :'source' => :'source',
        :'text' => :'text',
        :'type' => :'type'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'code' => :'Object',
        :'source' => :'Object',
        :'text' => :'Object',
        :'type' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::AddressValidationResultsMessage` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::AddressValidationResultsMessage`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'code')
        self.code = attributes[:'code']
      end

      if attributes.key?(:'source')
        self.source = attributes[:'source']
      end

      if attributes.key?(:'text')
        self.text = attributes[:'text']
      end

      if attributes.key?(:'type')
        self.type = attributes[:'type']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      code_validator = EnumAttributeValidator.new('Object', ['verification_error', 'unknown_street', 'component_mismatch_error', 'multiple_match', 'sub_premise_number_invalid', 'sub_premise_number_missing', 'premise_number_invalid', 'premise_number_missing', 'box_number_invalid', 'box_number_missing', 'pmb_number_missing', 'postal_code_change', 'administrative_area_change', 'locality_change', 'dependent_locality_change', 'street_name_change', 'street_type_change', 'street_directional_change', 'sub_premise_type_change', 'sub_premise_number_change', 'double_dependent_locality_change', 'subadministrative_area_change', 'subnational_area_change', 'po_box_change', 'premise_type_change', 'house_number_change', 'organization_change', 'extraneous_information', 'usps_door_inaccessible', 'administrative_area_partial', 'city_partial', 'street_partial', 'building_partial', 'subpremise_partial', 'administrative_area_full', 'city_full', 'thoroughfare_full', 'premises_full', 'subpremise_full', 'geocoded_street', 'geocoded_neighborhood', 'geocoded_community', 'geocoded_state', 'geocoded_rooftop', 'geocoded_interpolated_rooftop', 'invalid_postal_code', 'postal_code_not_found', 'empty_request', 'service_error', 'street_detail_missing', 'Invalid City/State/Zip', 'Default Match', 'Unknown Street', 'Address Not Found', 'Non-Deliverable ZIP4', 'Multiple Responses', 'Invalid Dual Address', 'Invalid State', 'Invalid City', 'Ambiguous Address'])
      return false unless code_validator.valid?(@code)
      source_validator = EnumAttributeValidator.new('Object', ['Shippo Address Validator', 'UPS'])
      return false unless source_validator.valid?(@source)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] code Object to be assigned
    def code=(code)
      validator = EnumAttributeValidator.new('Object', ['verification_error', 'unknown_street', 'component_mismatch_error', 'multiple_match', 'sub_premise_number_invalid', 'sub_premise_number_missing', 'premise_number_invalid', 'premise_number_missing', 'box_number_invalid', 'box_number_missing', 'pmb_number_missing', 'postal_code_change', 'administrative_area_change', 'locality_change', 'dependent_locality_change', 'street_name_change', 'street_type_change', 'street_directional_change', 'sub_premise_type_change', 'sub_premise_number_change', 'double_dependent_locality_change', 'subadministrative_area_change', 'subnational_area_change', 'po_box_change', 'premise_type_change', 'house_number_change', 'organization_change', 'extraneous_information', 'usps_door_inaccessible', 'administrative_area_partial', 'city_partial', 'street_partial', 'building_partial', 'subpremise_partial', 'administrative_area_full', 'city_full', 'thoroughfare_full', 'premises_full', 'subpremise_full', 'geocoded_street', 'geocoded_neighborhood', 'geocoded_community', 'geocoded_state', 'geocoded_rooftop', 'geocoded_interpolated_rooftop', 'invalid_postal_code', 'postal_code_not_found', 'empty_request', 'service_error', 'street_detail_missing', 'Invalid City/State/Zip', 'Default Match', 'Unknown Street', 'Address Not Found', 'Non-Deliverable ZIP4', 'Multiple Responses', 'Invalid Dual Address', 'Invalid State', 'Invalid City', 'Ambiguous Address'])
      unless validator.valid?(code)
        fail ArgumentError, "invalid value for \"code\", must be one of #{validator.allowable_values}."
      end
      @code = code
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] source Object to be assigned
    def source=(source)
      validator = EnumAttributeValidator.new('Object', ['Shippo Address Validator', 'UPS'])
      unless validator.valid?(source)
        fail ArgumentError, "invalid value for \"source\", must be one of #{validator.allowable_values}."
      end
      @source = source
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          code == o.code &&
          source == o.source &&
          text == o.text &&
          type == o.type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [code, source, text, type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
